package info.aspirecn.iov.yysj.product.check.common;

import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;

import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.iov.yysj.product.check.entity.ResponseObject;
import org.apache.tomcat.util.bcel.Const;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.netflix.zuul.context.RequestContext;
import lombok.extern.slf4j.Slf4j;

@Component
@Slf4j
public class ChannelRibbonHandle {
	@Resource(name = "getRestTemplate")
	RestTemplate restTemplate;
	@Autowired
	ObjectMapper objectMapper;
	@Autowired
	Property property;

	public ResponseObject channelRibbonHandle(String  token,String body, String userId) {
		ResponseObject responseObject = null;
		try{
				RequestContext.getCurrentContext().set("connectTimeout", property.getConnetTimeOut());
				RequestContext.getCurrentContext().set("readTimeout", property.getReadTimeOut()+1000);
			HttpHeaders headers = new HttpHeaders();
			log.info("channelRibbonHandle,userId:{}", userId);

			restTemplate.getMessageConverters().set(1,new StringHttpMessageConverter(StandardCharsets.UTF_8));
			MediaType type = MediaType.parseMediaType("application/json;charset=UTF-8");
			headers.setContentType(type);
			headers.add(Constants.HEADER_ACCEPT_KEY, MediaType.APPLICATION_JSON.toString()+";charset=UTF-8");
			headers.add(Constants.HEADER_TOKEN_KEY, token);
			headers.add(Constants.HEADER_USER_ID, userId);
			HttpEntity <String>httpEntity =null;
			ResponseEntity<ResponseObject> entity = null;
				httpEntity = new HttpEntity<String>(body,
						headers);
				entity = restTemplate.postForEntity(property.getGateWayUrl(), httpEntity,
						ResponseObject.class,new HashMap());

			if (entity != null && entity.getStatusCode() == HttpStatus.OK) {// 调用通道成功

				responseObject = entity.getBody();
				HttpHeaders httpHeaders = entity.getHeaders();
				List<String> prices = httpHeaders.get(Constants.price);

				if(prices!=null && prices.size()>=1){
					responseObject.setPrice(Integer.parseInt(prices.get(0)));
					RequestContext.getCurrentContext().getRequest().setAttribute(Constants.price,Integer.parseInt(prices.get(0)));
				}
				List<String> isCharges = httpHeaders.get("isCharge");

			/*	if(prices!=null && prices.size()>=1){
					responseObject.setPrice(Integer.parseInt(prices.get(0)));
				}*/
				if(isCharges!=null && isCharges.size()>=1){
					RequestContext.getCurrentContext().getRequest().setAttribute("isCharge",isCharges.get(0));
				}

			}
			log.info("responseObject:{}",responseObject);
		} catch (Exception ex) {
			log.error("ex:{}",ex);
		}
		return responseObject;
	}
}
