package info.aspirecn.iov.yysj.product.check.common;

import info.aspirecn.cloud.yysj.commons.lang.Constants;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpRequest;
import org.springframework.http.client.ClientHttpRequestExecution;
import org.springframework.http.client.ClientHttpRequestInterceptor;
import org.springframework.http.client.ClientHttpResponse;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.List;
@Component
@Slf4j
public class TraceIdInterceptor implements ClientHttpRequestInterceptor {


    @Override
    public ClientHttpResponse intercept(HttpRequest request, byte[] body, ClientHttpRequestExecution execution)
            throws IOException {
        HttpHeaders headers = request.getHeaders();
        //取出来设置的traceId的信息
        List<String> list = headers.get(Constants.HEADER_TRACEID_KEY);
        headers.add(Constants.HEADER_PARENT_TRACEID_KEY, list.get(0));
        //清除链路设置的traceId数据
        list.clear();
        //添加新的traceId数据
        list.add(headers.get("x-b3-spanid").get(0));
        // 保证请求继续被执行
        return execution.execute(request, body);
    }
}